

#include <SPI.h>
#include <Ethernet.h>

byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED }; //physical mac address
byte ip[] = { 192, 168, 0, 102 }; // ip in lan

EthernetServer server(80); //server port

String readString; 

//////////////////////
byte led1R = 9;
byte led1G = 8;
byte led1B = 7;
byte led2R = 6;
byte led2G = 5;
byte led2B = 4;

byte button1 = 3;
byte button2 = 2;



byte buttonState1 = LOW;
byte buttonState2 = LOW;


//variables
byte originalState = 1;
byte buttonPressed = 0;
void setup(){

  pinMode(4, OUTPUT); //pin selected to control
  pinMode(5, OUTPUT); //pin selected to control
  pinMode(6, OUTPUT); //pin selected to control
  //start Ethernet
  Ethernet.begin(mac, ip);
  server.begin();

  //enable serial data print 
  Serial.begin(9600); 
  Serial.println("servertest1"); // so I can keep track of what is loaded
  //buttons
  pinMode(button1, INPUT_PULLUP);
  pinMode(button2, INPUT_PULLUP);


  //LEDS
  pinMode(led1R, OUTPUT);
  pinMode(led1G, OUTPUT);
  pinMode(led1B, OUTPUT);
  
  pinMode(led2R, OUTPUT);
  pinMode(led2G, OUTPUT);
  pinMode(led2B, OUTPUT);
}

void loop(){
  //setting buttons
blink1();
  blink2();
  if(buttonPressed == 1) {
    if(buttonState1 == HIGH) {
      analogWrite(led2R, 255);
      analogWrite(led2B, 0);
      analogWrite(led2G, 0);

      analogWrite(led1R, 0);
      analogWrite(led1G, 0);
      analogWrite(led1B, 255);
      
    } else {
        analogWrite(led2R, 0);
        analogWrite(led2G, 0);
        analogWrite(led2B, 255);
  
        analogWrite(led1R, 255);
        analogWrite(led1G, 0);
        analogWrite(led1B, 0);
    }  
  } else if(buttonPressed == 2) {

      if(buttonState2 == HIGH) {
        analogWrite(led2R, 255);
        analogWrite(led2B, 255);
        analogWrite(led2G, 0);

        analogWrite(led1R, 0);
        analogWrite(led1G, 255);
        analogWrite(led1B, 255);
        delay(500);

        analogWrite(led2R, 255);
        analogWrite(led2B, 255);
        analogWrite(led2G, 70);

        analogWrite(led1R, 150);
        analogWrite(led1G, 255);
        analogWrite(led1B, 255);
        
        delay(500);


        analogWrite(led2R, 255);
        analogWrite(led2B, 200);
        analogWrite(led2G, 70);

        analogWrite(led1R, 150);
        analogWrite(led1G, 40);
        analogWrite(led1B, 125);
        
      } else {
        analogWrite(led2R, 255);
        analogWrite(led2B, 0);
        analogWrite(led2G, 0);
  
        analogWrite(led1R, 0);
        analogWrite(led1G, 0);
        analogWrite(led1B, 255);
      }

  }
  
  //done setting buttons
  // Create a client connection
  EthernetClient client = server.available();
  if (client) {
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();

        //read char by char HTTP request
        if (readString.length() < 100) {

          //store characters to string 
          readString += c; 
        } 

        //if HTTP request has ended
        if (c == '\n') {

          ///////////////
          Serial.println(readString);

          //now output HTML data header

          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
          client.println();

          client.println("<HTML>");
          client.println("<HEAD>");
          client.println("<TITLE>Arduino Led collor change</TITLE>");
          client.println("</HEAD>");
          client.println("<BODY>");

          client.println("<H1>choose either of: red, blue, green, yellow, purple to change the leds!</H1>");

          client.println("<FORM ACTION='/' method=get >");

          client.println("Change led 1: <INPUT TYPE=TEXT NAME='LED' VALUE='' SIZE='25' MAXLENGTH='50'>");

          client.println("<INPUT TYPE=SUBMIT NAME='submit' VALUE='Change!'>");
          
          client.println("<div style='margin-top:20px;' >");
          client.println("Change led 2: <INPUT TYPE=TEXT NAME='LED' VALUE='' SIZE='25' MAXLENGTH='50'>");

          client.println("<INPUT TYPE=SUBMIT NAME='submit2' VALUE='Change!'>");
          client.println("</div>");
          
          client.println("</FORM>");

          client.println("");

          client.println("</BODY>");
          client.println("</HTML>");

          delay(1);
          client.stop();

          /////////////////////
          if(readString.indexOf("red") == 15)//checks for on
          {
            digitalWrite(led2R, 255);    // set pin 4 high
            Serial.println(readString.indexOf("red"));
            delay(30);
          }

           if(readString.indexOf("blue") == 15)//checks for on
          { 
            digitalWrite(led2G, 0);
            digitalWrite(led2R, 0);
            digitalWrite(led2B, 255);    // set pin 4 high
            Serial.println(readString.indexOf("red"));
            delay(30);
          }

            if(readString.indexOf("green") == 15)//checks for on
          {
            digitalWrite(led2R, 0);    // set pin 4 high
            digitalWrite(led2B, 0);    // set pin 6 high
            digitalWrite(led2G, 255);
            Serial.println(readString.indexOf("red"));
            delay(30);
          }

            if(readString.indexOf("yellow") == 15)//checks for on
          {
            digitalWrite(led2R, 255);    // set pin 4 high
            digitalWrite(led2B, 0);    // set pin 6 high
            digitalWrite(led2G, 255);
            Serial.println(readString.indexOf("red"));
            delay(30);
          }

            if(readString.indexOf("purple") == 15)//checks for on
          {
            digitalWrite(led2R, 255);    // set pin 4 high
            digitalWrite(led2B, 255);    // set pin 6 high
            digitalWrite(led2G, 0);
            Serial.println(readString.indexOf("red"));
            delay(30);
          }

          //for first led

           if(readString.indexOf("red") == 10)//checks for on
          {
            digitalWrite(led1R, 255);    // set pin 4 high
            digitalWrite(led1G, 0);
            digitalWrite(led1B, 0);
            Serial.println(readString.indexOf("red"));
            delay(30);
          }

           if(readString.indexOf("blue") == 10)//checks for on
          { 
            digitalWrite(led1G, 0);
            digitalWrite(led1R, 0);
            digitalWrite(led1B, 255);    // set pin 4 high
            Serial.println(readString.indexOf("red"));
            delay(30);
          }

            if(readString.indexOf("green") == 10)//checks for on
          {
            digitalWrite(led1R, 0);    // set pin 4 high
            digitalWrite(led1B, 0);    // set pin 6 high
            digitalWrite(led1G, 255);
            Serial.println(readString.indexOf("red"));
            delay(30);
          }

            if(readString.indexOf("yellow") == 10)//checks for on
          {
            digitalWrite(led1R, 255);    // set pin 4 high
            digitalWrite(led1B, 0);    // set pin 6 high
            digitalWrite(led1G, 255);
            Serial.println(readString.indexOf("red"));
            delay(30);
          }

            if(readString.indexOf("purple") == 10)//checks for on
          {
            digitalWrite(led1R, 255);    // set pin 4 high
            digitalWrite(led1B, 255);    // set pin 6 high
            digitalWrite(led1G, 0);
            Serial.println(readString.indexOf("red"));
            delay(30);
          }

          
          if(readString.indexOf("off") == 10)//checks for off
          {
            digitalWrite(led1R, 0);    // set pin 4 high
            digitalWrite(led1B, 0);    // set pin 6 high
            digitalWrite(led1G, 0);
            delay(30);
          }

             if(readString.indexOf("off") == 15)//checks for off
          {
            digitalWrite(led2R, 0);    // set pin 4 high
            digitalWrite(led2B, 0);    // set pin 6 high
            digitalWrite(led2G, 0);
            delay(30);
          }

           if(readString.indexOf("animation") == 10)//checks for off
          { 
            digitalWrite(led2R, 255);    // set pin 4 high
            digitalWrite(led2B, 255);    // set pin 6 high
            digitalWrite(led2G, 255);
              digitalWrite(led1R, 255);    // set pin 4 high
              digitalWrite(led1G, 0);
              digitalWrite(led1B, 0);
              delay(500);
              digitalWrite(led1G, 0);
              digitalWrite(led1R, 0);
              digitalWrite(led1B, 255);    // set pin 4 high
              delay(500);
              digitalWrite(led1R, 0);    // set pin 4 high
              digitalWrite(led1B, 0);    // set pin 6 high
              digitalWrite(led1G, 255);\
              delay(500);
              digitalWrite(led1R, 255);    // set pin 4 high
              digitalWrite(led1B, 0);    // set pin 6 high
              digitalWrite(led1G, 255);
              delay(500);
              digitalWrite(led1R, 255);    // set pin 4 high
              digitalWrite(led1B, 255);    // set pin 6 high
              digitalWrite(led1G, 0);
          }

          
           if(readString.indexOf("animation") == 15)//checks for off
          { 
            digitalWrite(led1R, 255);    // set pin 4 high
            digitalWrite(led1B, 255);    // set pin 6 high
            digitalWrite(led1G, 255);
              digitalWrite(led2R, 255);    // set pin 4 high
              digitalWrite(led2G, 0);
              digitalWrite(led2B, 0);
              delay(500);
              digitalWrite(led2G, 0);
              digitalWrite(led2R, 0);
              digitalWrite(led2B, 255);    // set pin 4 high
              delay(500);
              digitalWrite(led2R, 0);    // set pin 4 high
              digitalWrite(led2B, 0);    // set pin 6 high
              digitalWrite(led2G, 255);\
              delay(500);
              digitalWrite(led2R, 255);    // set pin 4 high
              digitalWrite(led2B, 0);    // set pin 6 high
              digitalWrite(led2G, 255);
              delay(500);
              digitalWrite(led2R, 255);    // set pin 4 high
              digitalWrite(led2B, 255);    // set pin 6 high
              digitalWrite(led2G, 0);
          }

          if(readString.indexOf("party") == 15 || readString.indexOf("party") == 10)//checks for off
          { 
              digitalWrite(led1R, 255);    // set pin 4 high
              digitalWrite(led1G, 0);
              digitalWrite(led1B, 0);
              delay(300);

              digitalWrite(led2R, 255);    // set pin 4 high
              digitalWrite(led2G, 0);
              digitalWrite(led2B, 0);
              delay(300);
              
              digitalWrite(led1G, 0);
              digitalWrite(led1R, 0);
              digitalWrite(led1B, 255);    // set pin 4 high
              delay(300);

              digitalWrite(led2G, 0);
              digitalWrite(led2R, 0);
              digitalWrite(led2B, 255);    // set pin 4 high
              delay(300);
              
              digitalWrite(led1R, 0);    // set pin 4 high
              digitalWrite(led1B, 0);    // set pin 6 high
              digitalWrite(led1G, 255);\
              delay(300);

              digitalWrite(led2R, 0);    // set pin 4 high
              digitalWrite(led2B, 0);    // set pin 6 high
              digitalWrite(led2G, 255);\
              delay(300);
              
              digitalWrite(led1R, 255);    // set pin 4 high
              digitalWrite(led1B, 0);    // set pin 6 high
              digitalWrite(led1G, 255);
              delay(300);

              digitalWrite(led2R, 255);    // set pin 4 high
              digitalWrite(led2B, 0);    // set pin 6 high
              digitalWrite(led2G, 255);
              delay(300);
              
              digitalWrite(led1R, 255);    // set pin 4 high
              digitalWrite(led1B, 255);    // set pin 6 high
              digitalWrite(led1G, 0);
              delay(300);
            
              digitalWrite(led2R, 255);    // set pin 4 high
              digitalWrite(led2B, 255);    // set pin 6 high
              digitalWrite(led2G, 0);
              delay(300);
          }
          //clearing string for next read
          readString="";

        }
      }
    }
  }
}

void blink1() {
  byte ceva = digitalRead(button1);
  if(ceva != originalState) {
    buttonState1 = !buttonState1;
    buttonPressed = 1;
    delay(500);
  }
}

void blink2() {
  
byte ceva = digitalRead(button2);
  if(ceva != originalState) {
    buttonState2 = !buttonState2;
    buttonPressed = 2;
    delay(500);
  }
}
